package org.fluttercode.restwebdemo.bean;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.persistence.EntityManager;

import org.fluttercode.restwebdemo.model.Course;
import org.fluttercode.restwebdemo.qualifier.DataRepository;

@Stateless
@LocalBean
public class CourseDao {

	@Inject @DataRepository
	private EntityManager entityManager;
	
	public void save(Course course) {
		entityManager.persist(course);
	}
	
	public Course update(Course course) {
		return entityManager.merge(course);
	}
	
	public Course find(Long id) {
		Course c = entityManager.find(Course.class, id);
		System.out.println("Student count -= "+ c.getStudents().size());
		return c;
	}
}
 