package org.fluttercode.restwebdemo.service;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

import org.fluttercode.restwebdemo.bean.CourseDao;
import org.fluttercode.restwebdemo.model.Course;

@Stateless
@LocalBean
@Path("course")
public class CourseService {
	

	@Inject
	private CourseDao courseDao;
	
	@Path("courseName/{id}")
	@GET
	public String getCourseName(@PathParam("id") Long id) {
		Course course = courseDao.find(id);
		if (course == null) {
			return "Course not found";
		} else {
			return course.getTitle();
		}
	}
	
	@Path("find/{id}/xml")
	@GET
	@Produces(MediaType.APPLICATION_XML)
	public Course getCourseAsXml(@PathParam("id") Long id) {
		return courseDao.find(id);
	}
	
	@Path("find/{id}/json")
	@GET
	@Produces(MediaType.APPLICATION_JSON)
	public Course getCourseAsJson(@PathParam("id") Long id) {
		return courseDao.find(id);
	}
	
	
	@Path("create")
	@PUT
	@Produces(MediaType.APPLICATION_JSON)
	public Course createCourse(@FormParam("title") String title,@FormParam("code") String code) {
		System.out.println("Createing course "+title+ " "+ code);
		Course course = new Course();
		course.setTitle(title);
		course.setCode(code);		
		courseDao.save(course);		
		return course;
	}
	
}
