package org.fluttercode.restwebdemo.service;

import java.util.Date;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

import org.fluttercode.restwebdemo.model.Course;

@Path("sample")
@Stateless
public class SimpleService {

	@PersistenceContext
	private EntityManager entityManager;

	@Path("greet")
	@GET
	public String doGreet() {
		return "Hello Stranger, the time is " + new Date();
	}

	@Path("sayHello/{name}")
	@GET
	public String doSayHello(@PathParam("name") String name) {
		return "Hello there " + name;
	}

	@Path("sayHello")
	@GET
	public String doSayHelloWithRequestParam(@QueryParam("name") String name) {
		return "Hi there " + name;
	}

	@Path("sayHello")
	@POST
	@Produces(MediaType.APPLICATION_XML)
	public String doSayHelloWithFormParam(@FormParam("name") String name) {
		return "<message>Hi there " + name + "</message>";
	}

	@Path("courseName/{id}")
	@GET
	public String getCourseNameFromId(@PathParam("id") Long id) {
		Course c = entityManager.find(Course.class, id);
		if (c == null) {
			return "Not Found, try the index <a href='/restwebdemo/'>page</a> and come back";
		} else {
			return c.getTitle();
		}
	}

	public EntityManager getEntityManager() {
		return entityManager;
	}

	public void setEntityManager(EntityManager entityManager) {
		this.entityManager = entityManager;
	}
}
